//---------------------------------------------------------------------------

#include <vcl.h>
#include <string.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    // Grundeinstellungen
    BitBtnClose->Enabled = false;
    bCom = false;
    StatusBar1->SimpleText = "Please, open com.";
    ComNo[0] = "COM1";
    ComNo[1] = "COM2";
    nNo = 0;
    hSerial = NULL;
    BitBtnRead->Enabled = false;

    // Titel der Komponente TValueListEditor ndern
    TStringList *TempList = new TStringList; // Liste deklarieren
      	//Stringliste benutzen
        TempList->Add( "Address");
        TempList->Add( "Value");
        ValueListEditorPage->TitleCaptions = TempList;
    delete TempList; // Stringlistenobjekt freigeben
}
//---------------------------------------------------------------------------
//  Page aus DS1616 lesen
//---------------------------------------------------------------------------
void TForm1::ReadPage( unsigned char HighAdr, unsigned char LowAdr )
{
  // Befehl 0x33 senden
  TransmitCommChar( hSerial, 0x33 );
  // High Adresse senden
  TransmitCommChar( hSerial, HighAdr );
  // Low Adresse senden
  TransmitCommChar( hSerial, LowAdr );
} // ReadPage

//---------------------------------------------------------------------------

void __fastcall TForm1::BitBtnOpenClick(TObject *Sender)
{
    if ( OpenCom() == 0 )
    {   // Alles OK
        BitBtnOpen->Enabled = false;
        BitBtnClose->Enabled = true;
        StatusBar1->SimpleText = "Com open.";
        BitBtnRead->Enabled = true;
    }
    else
    {     // Fehler
          BitBtnOpen->Enabled = true;
          BitBtnClose->Enabled = false;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtnCloseClick(TObject *Sender)
{
    CloseCom();
    BitBtnOpen->Enabled = true;
    BitBtnClose->Enabled = false;
    StatusBar1->SimpleText = "Com close.";
    ShapeOnline->Brush->Color = clBtnFace;
    BitBtnRead->Enabled = false;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//  Schnittstelle schliesen
//---------------------------------------------------------------------------
void TForm1::CloseCom( void )
{
  // Wenn Schnittstelle offen , dann schliesen
  if( bCom == true )
  {
    if( hSerial != NULL )
    {
      // Alten Timeout wieder herstellen
      SetCommTimeouts( hSerial, &ComTimeOld );
      CloseHandle( hSerial );
    }
  }
  bCom = false;
} // CloseCom
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    CloseCom();
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// Schnittstelle ffnen
//---------------------------------------------------------------------------
int TForm1::OpenCom( void )
{
  // Schnittstelle auswhlen
  if( RadioButtonCom1->Checked == true ) nNo = 0;
  if( RadioButtonCom2->Checked == true ) nNo = 1;

  // Schnittstelle ffnen
  if( bCom == false )
  {
    hSerial = CreateFile( ComNo[nNo],
                          GENERIC_READ | GENERIC_WRITE,
                          0,
                          0,
                          OPEN_EXISTING,
                          0,
                          0 );
    if( hSerial == INVALID_HANDLE_VALUE )
    {
        // ffnen fehlgeschlagen
        bCom = false;
        nError = GetLastError();
        StatusBar1->SimpleText = "Can not open COMM. Error : " + IntToStr(nError);
        BitBtnOpen->Enabled = true;
        BitBtnClose->Enabled = false;
        ShapeOnline->Brush->Color = clBtnFace;
        return 1;
    }
    else
    {
      // Alles funktioniert
      bCom = true;
      StatusBar1->SimpleText = "Serial Comm open.";

      // Aktuelle DCB Struktur einlesen
      comDCB.DCBlength = sizeof(DCB);
      nError = GetCommState( hSerial, &comDCB );
      if( nError == 0 )
        StatusBar1->SimpleText = "Error : GetCommState";

      // DCB fllen, Parameter fr ds1616
      comDCB.BaudRate = 9600;
      comDCB.ByteSize = 8;
      comDCB.Parity   = NOPARITY;
      comDCB.StopBits = ONESTOPBIT;
      comDCB.fDtrControl = DTR_CONTROL_DISABLE;

      nError = SetCommState( hSerial, &comDCB );
      if( nError == 0 )
      {
        StatusBar1->SimpleText = "Error : SetCommState";
        return 1;
      }

       // Timeout bearbeiten
       GetCommTimeouts( hSerial, &ComTimeOld ); // Alte Werte speichern
       ComTimeNew.ReadIntervalTimeout         = 0;
       ComTimeNew.ReadTotalTimeoutConstant    = 0;
       ComTimeNew.ReadTotalTimeoutMultiplier  = 200;  // 200 ms
       ComTimeNew.WriteTotalTimeoutMultiplier = 0;
       ComTimeNew.WriteTotalTimeoutConstant   = 0;
       SetCommTimeouts( hSerial, &ComTimeNew );

      // DTR = +5V fr Elektor Klimate Logger
      nError = EscapeCommFunction( hSerial, SETDTR );
      if( nError == 0 )
      {
        StatusBar1->SimpleText = "Error : EscapeCommFunction";
        return 1;
      }

      // Auf 00h vom Interface warten
      dwRead = 0;
      int nTimeOut = 0;
      do
      {
        ReadFile( hSerial, cPage, 2, &dwRead, NULL );
        Application->ProcessMessages();
        nTimeOut++;
        Sleep(1);
        StatusBar1->SimpleText = "nTimeOut : " + IntToStr(nTimeOut);
        if( nTimeOut > 10 )
        {
          StatusBar1->SimpleText = "Error : Timeout Comm";
          CloseCom();
          return 1;
        }
      }
      while( dwRead == 0 );

      ShapeOnline->Brush->Color = clLime;
      StatusBar1->SimpleText = "DS1616 online : " + IntToHex(cPage[0],1 );
    }
  }
  return 0;
} // OpenCom

//---------------------------------------------------------------------------
//  Angegebene Seite von DS1616 lesen und ausgeben
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtnReadClick(TObject *Sender)
{
  int nPage;
  Byte bHighAdr = 0x0;
  Byte bLowAdr  = 0x0;
  WORD wAdr;
  int nRow = 0;

  try
  {
    nPage  = StrToInt( EditNo->Text );
  }
  catch(...)
  {
        Application->MessageBoxA(  "Pease, only integer!" ,"Error" , MB_OK );
    return;
  }

  if ( nPage < 0 | nPage > 192 )
  {
    Application->MessageBoxA(  "Wrong value ( 0 to 192 ) !" ,"Error" , MB_OK );
    return;
  }
  // Zahlenwert umwandeln
  wAdr = nPage * 32;

  // Aufteilen in Low und High Adresse
  bLowAdr  = wAdr;
  bHighAdr = wAdr >> 8;
  // Seite lesen

  ReadPage( bHighAdr, bLowAdr );

  // Auf Zeichen warten
  PageWork();

  nRow = ValueListEditorPage->RowCount;
  if( nRow > 2 )
  { // Alle Werte lschen im ValueListEditorPage
    for( int n = 0; n < 0x20 ; n++ )
    {
        nRow--;
        ValueListEditorPage->DeleteRow(nRow);
    }
  }

  // Ausgelesene Werte int Tabelle eintragen
  for( int n = 0; n < 0x20 ; n++ )
  {
    ValueListEditorPage->InsertRow( IntToHex(bHighAdr,2 )+ "  " + IntToHex( bLowAdr + n, 2 ) ,
    IntToHex( cPage[n], 2 ) + " Hex ( " + ConvertBin( IntToHex( cPage[n], 2 ) ) + " ) ", false );
  }

}
//---------------------------------------------------------------------------
//  Daten empfangen und zuweisen
//---------------------------------------------------------------------------
void TForm1::PageWork( void )
{
  int nCountChar = 0;
  int nTimeOut = 0;
  char cData[34];

  int nCharRead = 0;

  do
  {
    dwRead = 0;
    nTimeOut = 0;
    do
    {
//        Sleep(1);
        ReadFile( hSerial, cData, 34, &dwRead, NULL );
        Application->ProcessMessages();
        nTimeOut++;
        if( nTimeOut > 1000 )
        {
          StatusBar1->SimpleText = "Error : Timeout Comm" ;
          return;
        }
        StatusBar1->SimpleText = "nTimeOut : " + IntToStr(nTimeOut);
    }
    while( dwRead == 0 );

    for( int n = 0; n < (int)dwRead; n++ )
    {
      cPage[nCharRead] = cData[n];
      nCharRead++;
    }

    nCountChar += dwRead;
    // Zeichen zusammensetzen


  }while( nCountChar < 34 );
  StatusBar1->SimpleText =  IntToStr(nCountChar) + " character received.";

} //  void PageWork( void )
//---------------------------------------------------------------------------
// Umwandlung : Hex - Zahl in Binr - Zahl
// Beide Variablen mssen eine AnsiString sein.
// Buchstaben die nicht im Wertebereich liegen werden ignoriert.
//---------------------------------------------------------------------------
AnsiString TForm1::ConvertBin( AnsiString asHex )
{
    AnsiString asHelp, asSub, asBin;
    // Lnge der Variable bestimmen
    int nSign = asHex.Length();
    // Umwandeln in Grossbuchstaben
    asHelp = asHex.UpperCase();

    for( int n = 1; n < ( nSign +1 ); n++ )
    {
        asSub = asHelp.SubString(n,1);
        if( asSub == "0" ) asBin += "0000";
        if( asSub == "1" ) asBin += "0001";
        if( asSub == "2" ) asBin += "0010";
        if( asSub == "3" ) asBin += "0011";
        if( asSub == "4" ) asBin += "0100";
        if( asSub == "5" ) asBin += "0101";
        if( asSub == "6" ) asBin += "0110";
        if( asSub == "7" ) asBin += "0111";
        if( asSub == "8" ) asBin += "1000";
        if( asSub == "9" ) asBin += "1001";
        if( asSub == "A" ) asBin += "1010";
        if( asSub == "B" ) asBin += "1011";
        if( asSub == "C" ) asBin += "1100";
        if( asSub == "D" ) asBin += "1101";
        if( asSub == "E" ) asBin += "1110";
        if( asSub == "F" ) asBin += "1111";
        // Zur besseren Lesbarkeit
        asBin += " ";
    }
    asBin += "- 2";
    return asBin;
}   // ConvertBin

